services:
  - docker:24.0.5-dind

variables:
  DOCKER_HOST: "tcp://docker:2375"
  DOCKER_DRIVER: overlay2
  RUN_TEST_BUILD: 0

.deploy_image:
  image: bananawhite98/ubuntu:1
  stage: deploy
  tags:
    - gitlab-org-docker
  rules:
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      changes:
        - ${DOCKER_IMAGE_DIR}/*
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      changes:
        - ${DOCKER_IMAGE_DIR}/*
        - java_files/*
  before_script:
    - docker login -u ${DOCKER_HUB_USERNAME} -p ${DOCKER_HUB_PASSWORD} ${DOCKER_REGISTRY}
  script:
    - cd linters/
    - make linters DOCKER_REGISTRY=${DOCKER_REGISTRY} VERSION=${DOCKER_IMAGE_VERSION}
    - make qodana DOCKER_REGISTRY=${DOCKER_REGISTRY} VERSION=${DOCKER_IMAGE_VERSION}
  after_script:
    - docker logout
    - cd linters/
    - make rmi-all DOCKER_REGISTRY=${DOCKER_REGISTRY} VERSION=${DOCKER_IMAGE_VERSION}
